export declare type EosioAuthorizationObject = {
    actor: string;
    permission: string;
};
export declare type EosioActionObject = {
    account: string;
    name: string;
    authorization: EosioAuthorizationObject[];
    data: any;
};
export declare class ActionGenerator {
    readonly contract: string;
    readonly token_contract: string;
    constructor(contract: string, token_contract: string);
    createDao(authorization: EosioAuthorizationObject[], owner: string, description: string, token: string): Promise<EosioActionObject[]>;
    createProposal(authorization: EosioAuthorizationObject[], proposer: string, dao_id: number, title: string, summary: string, url: string, vote_start: string, vote_end: string): Promise<EosioActionObject[]>;
    createNFTProposal(authorization: EosioAuthorizationObject[], proposer: string, dao_id: number, side: string, asset_ids: number[], price: string, vote_start: string, vote_end: string): Promise<EosioActionObject[]>;
    createRetireProposal(authorization: EosioAuthorizationObject[], proposer: string, dao_id: number, from: string, quantity: string, vote_start: string, vote_end: string): Promise<EosioActionObject[]>;
    vote(authorization: EosioAuthorizationObject[], from: string, quantity: string, proposal_type: string, dao_id: string, proposal_id: string, option: string): Promise<EosioActionObject[]>;
    protected _pack(account: string, authorization: EosioAuthorizationObject[], name: string, data: any): EosioActionObject[];
}
