"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionGenerator = void 0;
/* tslint:disable:variable-name */
class ActionGenerator {
    constructor(contract, token_contract) {
        this.contract = contract;
        this.token_contract = token_contract;
    }
    async createDao(authorization, owner, description, token) {
        return this._pack(this.contract, authorization, "crtdao", {
            owner,
            description,
            token
        });
    }
    async createProposal(authorization, proposer, dao_id, title, summary, url, vote_start, vote_end) {
        return this._pack(this.contract, authorization, "crtproposal", {
            proposer,
            dao_id,
            title,
            summary,
            url,
            vote_start,
            vote_end
        });
    }
    async createNFTProposal(authorization, proposer, dao_id, side, asset_ids, price, vote_start, vote_end) {
        return this._pack(this.contract, authorization, "crtnftprl", {
            proposer,
            dao_id,
            side,
            asset_ids,
            price,
            vote_start,
            vote_end
        });
    }
    async createRetireProposal(authorization, proposer, dao_id, from, quantity, vote_start, vote_end) {
        return this._pack(this.contract, authorization, "crtretireprl", {
            proposer,
            dao_id,
            from,
            quantity,
            vote_start,
            vote_end
        });
    }
    async vote(authorization, from, quantity, proposal_type, dao_id, proposal_id, option) {
        return this._pack(this.token_contract, authorization, "transfer", {
            from: from,
            to: this.contract,
            quantity: quantity,
            memo: `vote:${proposal_type};dao_id:${dao_id};proposal_id:${proposal_id};option:${option}`
        });
    }
    _pack(account, authorization, name, data) {
        return [{ account, name, authorization, data }];
    }
}
exports.ActionGenerator = ActionGenerator;
